require "level"
require "player"
require "menu"
require "conf"

function love.load()
	startup()
end

function love.keyreleased(key)
	playerReset(key)
end

function startup()

	gamestate = "Menu"
	baseTimer = {}
	baseTimer.enabled = false
	baseTimer.val = 0
	seconds = 0
	qseconds = 0
	rseconds = 0
	Small = love.graphics.newFont("PixelSplitter-Bold.ttf",15)
	Medium = love.graphics.newFont("PixelSplitter-Bold.ttf",30)
	Large = love.graphics.newFont("PixelSplitter-Bold.ttf",60)
	local g = love.graphics
	Madeby = "Made by Callum Breslin - 2015"
	Late = "Too late! You died."
	cores = love.system.getProcessorCount()
	os_string = love.system.getOS()
	GameBG = g.newImage("Sprites/Skyline.png")
	MenuBG = g.newImage("Sprites/Back.png")
	Title = g.newImage("Sprites/Title.png")
	Para = g.newImage("Sprites/titlePara.png")
	g.setColor(255,255,255)
end

function love.update(dt)
	if dt < 1/60 then
      love.timer.sleep(1/60 - dt)
    end
	if gamestate == "Playing" then
		updatePlayer(dt)
	end
	if gamestate == "Menu" then
		updateHeli(dt)
		buttonSpawn(287,300,"Start","Start")
		buttonSpawn(307.5,380,"Help","Help")
		buttonSpawn(310.5,460,"Quit","Quit")
	end
	levelCollide()
	updateTimer(dt)
	if player.state == "parachute" then
		baseTimer.enabled = false
	end
	if player.state ~= "standing" and player.state ~= "heli" then
		buttonSpawn(560,530,"Reset","Reset")
	end
	if player.state == "landed" and player.dead == false then
		player.yvel = 0
	end
end

function love.draw()
	local g = love.graphics
	if gamestate == "Playing" then
		g.draw(GameBG,0,0)
		g.setFont(Medium)
		drawLevel(1)
		drawPlayer()
		Helicopter.rPic:setFilter("nearest","nearest")
		love.graphics.draw(Helicopter.rPic,Helicopter.x + 360,Helicopter.y + 5,rnum,4)
		if player.state == "falling" then
			baseTimer.enabled = true
			g.print(seconds,0,30)
		end
	end
	if gamestate == "Menu" then
		g.draw(MenuBG,0,0)
		g.draw(Title,(800-Title:getWidth())/2,200)
		g.draw(Para,(800-Para:getWidth())/2,200-Para:getHeight())
		g.setFont(Small)	
		g.print(Madeby,400 - Small:getWidth(Madeby)/2, 600)
		drawHeli()
	end
	if gamestate == "Menu" or gamestate == "Playing" or gamestate == "Landed" then
		buttonDraw()
		x, y = love.mouse.getPosition( )
		buttonMouse(x,y)
	end
	if player.state == "landed" and player.dead == false then
		g.setFont(Medium)
		g.setColor(255,255,255)
		g.print("You got: "..seconds.." seconds",(800 - 386) / 2, 300)
	end
	if player.dead == true then
		gamestate = "Landed"
		g.setFont(Medium)
		g.setColor(255,255,255)
		g.print(Late,400 - Medium:getWidth(Late)/2,200)
	end
	-- Info
		g.setFont(Small)	
		g.setColor(255,255,255)
		
		g.print("OS: "..os_string,0,0)
		g.print("Cores: "..cores,0,15)
		g.print("FPS: "..love.timer.getFPS(), 0,30)
end

function love.mousepressed(x, y, button)
	buttonClick(x,y)
end

function love.quit()
	love.event.quit()
end

function updateTimer(dt)
	baseTimer.val = baseTimer.val + dt
	if baseTimer.enabled == true then
		if baseTimer.val > 0.05 then
  			baseTimer.val = baseTimer.val - 0.05
	 		qseconds = qseconds + 0.05
	 	end
	end

	if qseconds >= 0.1 then
		qseconds = 0
		rseconds =  rseconds + 0.1
		seconds = seconds + 0.1
	end
end